package fmon.builder

import java.io.File
import scalafx.util.StringConverter

object FilenameConverter extends StringConverter[File] {
  override def toString(f: File) = if (f != null) f.getName else "<none>"
  override def fromString(s: String) = if (s == "<none>") null else new File(s)
}