package fmon.builder.dialog

import javafx.fxml.FXML
import javafx.scene.{control => jfxsc, layout => jfxsl, Parent, Scene}

import scalafx.Includes._
import scalafx.scene.control.SpinnerValueFactory

import fmon.world.GameMap

class MapProperties {
  @FXML var widthSpin: jfxsc.Spinner[Int] = _
  @FXML var heightSpin: jfxsc.Spinner[Int] = _
  
  @FXML def initialize(): Unit = {
    println(widthSpin)
  }
  
  def init(level: GameMap): Unit = {
    widthSpin.valueFactory().value = level.width
    heightSpin.valueFactory().value = level.height
  }
  
  def width = widthSpin.value()
  def height = heightSpin.value()
}