
import scala.language.implicitConversions
import scala.util.Random

import fmon.stat._
import fmon.util.{Dice, IntFraction}

package object fmon {
  type Direction = fmon.util.Direction.Val
  
  implicit def rngDice(rng : Random) = new Dice(rng)
  implicit def int2Helper(x : Int) = new IntFraction(x)
  implicit def ptrToMonster(ptr : MonsterPtr) : Monster = ptr.mon
}